/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionDatasetRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionDatasetRequest{}

// AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionDatasetRequest struct for AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionDatasetRequest
type AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionDatasetRequest struct {
	OAuthId   *int32 `json:"oAuthId,omitempty"`
	ProjectId *int32 `json:"projectId,omitempty"`
}

// NewAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionDatasetRequest instantiates a new AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionDatasetRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionDatasetRequest() *AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionDatasetRequest {
	this := AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionDatasetRequest{}
	return &this
}

// NewAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionDatasetRequestWithDefaults instantiates a new AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionDatasetRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionDatasetRequestWithDefaults() *AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionDatasetRequest {
	this := AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionDatasetRequest{}
	return &this
}

// GetOAuthId returns the OAuthId field value if set, zero value otherwise.
func (o *AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionDatasetRequest) GetOAuthId() int32 {
	if o == nil || IsNil(o.OAuthId) {
		var ret int32
		return ret
	}
	return *o.OAuthId
}

// GetOAuthIdOk returns a tuple with the OAuthId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionDatasetRequest) GetOAuthIdOk() (*int32, bool) {
	if o == nil || IsNil(o.OAuthId) {
		return nil, false
	}
	return o.OAuthId, true
}

// HasOAuthId returns a boolean if a field has been set.
func (o *AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionDatasetRequest) HasOAuthId() bool {
	if o != nil && !IsNil(o.OAuthId) {
		return true
	}

	return false
}

// SetOAuthId gets a reference to the given int32 and assigns it to the OAuthId field.
func (o *AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionDatasetRequest) SetOAuthId(v int32) {
	o.OAuthId = &v
}

// GetProjectId returns the ProjectId field value if set, zero value otherwise.
func (o *AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionDatasetRequest) GetProjectId() int32 {
	if o == nil || IsNil(o.ProjectId) {
		var ret int32
		return ret
	}
	return *o.ProjectId
}

// GetProjectIdOk returns a tuple with the ProjectId field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionDatasetRequest) GetProjectIdOk() (*int32, bool) {
	if o == nil || IsNil(o.ProjectId) {
		return nil, false
	}
	return o.ProjectId, true
}

// HasProjectId returns a boolean if a field has been set.
func (o *AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionDatasetRequest) HasProjectId() bool {
	if o != nil && !IsNil(o.ProjectId) {
		return true
	}

	return false
}

// SetProjectId gets a reference to the given int32 and assigns it to the ProjectId field.
func (o *AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionDatasetRequest) SetProjectId(v int32) {
	o.ProjectId = &v
}

func (o AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionDatasetRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionDatasetRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.OAuthId) {
		toSerialize["oAuthId"] = o.OAuthId
	}
	if !IsNil(o.ProjectId) {
		toSerialize["projectId"] = o.ProjectId
	}
	return toSerialize, nil
}

type NullableAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionDatasetRequest struct {
	value *AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionDatasetRequest
	isSet bool
}

func (v NullableAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionDatasetRequest) Get() *AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionDatasetRequest {
	return v.value
}

func (v *NullableAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionDatasetRequest) Set(val *AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionDatasetRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionDatasetRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionDatasetRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionDatasetRequest(val *AppDestinationGoogleBigQueryGoogleBigQueryDestinationActionDatasetRequest) *NullableAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionDatasetRequest {
	return &NullableAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionDatasetRequest{value: val, isSet: true}
}

func (v NullableAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionDatasetRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableAppDestinationGoogleBigQueryGoogleBigQueryDestinationActionDatasetRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
